# Installation

Mutt est un client mail utilisé en ligne de commande.
Son interface utilise "ncurses".

~~~
# apt install mutt
~~~

# Commandes

## Guide de survie

~~~{.bash}
? : "Aide"
m : "Rédiger un nouveau mail"
r : "Répondre"
g : "Répondre à tous"
y : "Naviguer dans les sous-Maildir"
w : "Appliquer un flag sur le mail"
W : "Supprimer un flag sur le mail"
o : "Trier les mails"
<Tab> | j : "Sélectionner le mail non lu suivant"
s : "Sauvegarder le mail"
v : "Regarder pièces-jointes"
d : "Supprimer le mail courant"
D : "Supprimer tous les mails correspondant à la recherche"
> : "Défiler la liste des mails vers le bas"
< : "Défiler la liste des mails vers le haut"
q : "Quitter l'écran"
i : "Revenir à l'index"
t : "taguer le mail courant"
T : "taguer tous les mails correspondant à la recherche"
~~~

## Quelques séquences utiles

### Jeter un œil sur une série de mails avant de les déplacer en masse :

* Dans la liste des messages ;
* `l` pour filtrer la liste ;
* `~s '\[evomaintenance\]'` le sujet doit contenir `[evomaintenance]` ;
* une fois les mails parcourus ;
* `T` pour taguer tous les mails (la recherche est normalement rappelée, il suffit de valider) ;
* `;s` pour indiquer qu'on veut déplacer tous les mails tagués ;
* saisie du dossier cible, par exemple `=.evomaintenance/`.

## Astuces de configuration

Stocker ses mails dans Maildir et utiliser un dossier brouillon et une copie d'envoi.

~~~{.bash}
set folder="~/Maildir"
set spoolfile = ~/Maildir
set record="+.Sent"
set postponed="+.Drafts"
~~~

Garder un historique des commandes et motifs de recherche :

~~~{.bash}
set history=1024
set save_history=2048
set history_file="~/.mutt/history"
~~~

Trier par thread par défaut, avec le thread entier qui suit la date du dernier message :

~~~{.bash}
set sort=threads # default sort messages by thread
set sort_browser=reverse-date # showing mbox list default to newest first
set sort_aux=last-date-received # showing threads with youngest message last
~~~

Format de date plus complet :

~~~{.bash}
set date_format="%Y-%m-%d %H:%M"
set index_format="%2C | %Z [%d] %-30.30F (%-4.4c) %s"
~~~
