**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**

# Howto NTP

Le protocole NTP (Network Time Protocol) permet de maintenir à l'heure un ordinateur.

## Installation

Installer un serveur NTP sous Linux :

~~~
# apt install ntp
~~~

On le configure via le fichier _/etc/ntp.conf_.

## NTP sous OpenBSD

OpenBSD installe par défaut OpenNTPD.

Pour forcer une synchronisation immédiate :

~~~
# ntpd -s
~~~

## Serveur NTP uniquement pour la machine

Pour un serveur utilisé uniquement pour la machine,
on aura principalement les directives suivantes :

~~~
# Le ou les serveurs sur lesquels on veut se synchroniser
server ntp.evolix.net

# Cette ligne sert à autoriser le contrôle TOTAL de l'horloge pour la machine locale
# ce qui est le but recherché. 
# On autorise toute requête de synchronisation DEPUIS notre serveur
restrict 127.0.0.1
restrict ::1

# On interdit toute requête de synchronisation VERS notre serveur
restrict -4 ignore
restrict -6 ignore

~~~

## Serveur NTP public

Pour un serveur sur lequel viendrait se synchroniser d'autres machines :

~~~
# Plusieurs serveurs (de strate 2 a priori)
# Voir <http://support.ntp.org/bin/view/Servers/StratumTwoTimeServers>
server ntp1.example.com
server ntp2.example.com
server ntp3.example.com
server ntp4.example.com

# Autoriser l'accès en lecture uniquement depuis partout
restrict -4 default kod notrap nomodify nopeer noquery
restrict -6 default kod notrap nomodify nopeer noquery

# On autorise toujours notre propre machine à modifier son horloge
restrict 127.0.0.1
restrict ::1
~~~

## Outils

On vérifie son bon fonctionnement via :

~~~
# ntpq -p
     remote           refid      st t when poll reach   delay   offset  jitter
==============================================================================
 ntp.example.com 213.251.153.35   3 u   50   64    3   19.404  -10.832   8.768
~~~

On peut voir la liste des clients qui se connectent au serveur via :

~~~
# ntpdc -c monlist
remote address          port local address      count m ver rstr avgint  lstint
===============================================================================
server1.example.com 41342 192.0.43.123        6404 3 4    1d0     27       2
server2.example.com 34764 192.0.43.123        6412 3 4    1d0     27       2
server3.example.com 44168 192.0.43.123        6970 3 4    1d0     25      10
server4.example.com 58051 192.0.43.123        2495 3 4    1d0     70      16
server5.example.com   123 192.0.43.123        2640 3 4    1d0     66      30
~~~

## Courbes Munin

Pour les serveurs utilisant un serveur NTP uniquement pour leurs besoins, Munin
intègre par défaut des scripts pour surveiller le décalage par rapport à un/des serveur(s) de
temps. Il ne reste qu'à les activer.

Pour les serveurs NTP, les plugins ne sont pas officiels (_ntp_queries_ trouvables sur Internet...)

