---
title: Howto Weechat
categories: tips
...

* <https://weechat.org/>
* <https://weechat.org/files/doc/stable/weechat_user.fr.html>


**Weechat** 

## Installation

Sur Debian :

~~~{.bash}
apt install weechat
~~~

Sur OpenBSD :

~~~{.bash}
pkg_add weechat
~~~

## Configuration rapide

Lancer weechat :

~~~{.bash}
$ weechat
~~~

*Changer son nick, username, realname*

~~~
/set irc.server_default.nicks "foo"
/set irc.server_default.username "foo"
/set irc.server_default.realname "foo bar"
~~~

*Configurer ses highlights*

Mots à «highlighter»

~~~
/set weechat.look.highlight foo,bar
~~~

Faire des highlights un peu plus sophistiqués (ie: à base de regex)

~~~
/set weechat.look.highlight_regex ^\*|^\* :|^\*:
~~~

Couleur des highlights dans les channels

~~~
/set weechat.color.chat_highlight yellow
/set weechat.color.chat_highlight_bg red
~~~

Couleur des highlights dans la bar de status

~~~
/set weechat.color.status_data_highlight red
/set weechat.color.status_data_private red
~~~

*Ajouter des servers avec connexion automatique*

~~~
/server add freenode irc.freenode.net/6667 -autoconnect
~~~

*Ajouter des channels avec connexion automatique*

~~~
/set irc.server.freenode.autojoin "#debian,#openbsd,#evolix"
~~~

*Être highlighté à chaque message dans le canal courrant*

~~~
/buffer set highlight_regex .*
~~~

*Ordonner ses buffers*
Exemple: Inverser les buffers 3 et 4

~~~
/buffer swap 4 3
~~~


*Sauvegarder*

~~~
/save
~~~
