# Tips Vim

* <http://www.vim.org/docs.php>
* <https://bitbucket.org/tednaleid/vim-shortcut-wallpaper/src>
* <http://vimsheet.com>
* <http://people.csail.mit.edu/vgod/vim/vim-cheat-sheet-en.pdf>

## Help

~~~{.bash}
:help <cmd> : "avoir de l'aide sur une commande"
~~~

## Commandes de base

~~~{.bash}
i : "passer en mode «Insert» - à gauche du curseur"
I : "passer en mode «Insert» - en début de phrase"
a` : "passer en mode «Insert» - à droite du curseur"
A : "passer en mode «Insert» - en fin de phrase"
Échap : "passer en mode «Edit» – sauf si vous avez le nouveau MacBook Pro sans cette touche ;)"
:q! : "quitter sans sauvegarder"
:wq : "sauvegarder et quitter"
dd : "supprimer (et copier) une ligne - ajoute la ligne dans le buffer"
v : "sélection du texte à partir du curseur"
V : "sélection du texte par ligne"
y : "copier - ajoute la sélection dans le buffer"
Y : "copier la ligne - ajoute dans le buffer"
p : "coller le buffer"
x ou . : "effacer le caractère à droite"
X : "effacer le caractère à gauche"
u : "undo"
C-r : "redo"
~~~

## Commandes avancées

### Mode "Insert"

~~~{.bash}
CTRL-V u XXXX : "où `XXXX` est le code du caractère UTF8"
~~~

### Mode "Edit"

~~~{.bash}
r : "remplacer un caractère"
c[0|^|w|$|G] : "changer (supprime et passe en mode insertion)"
d : "supprimer"
~ : "inverser la casse d'un caractère"
:set paste` / `:set nopaste : "passer en mode copier/coller (et revenir)"
~~~

paramètres possibles pour changer/supprimer :

~~~{.bash}
0 : "début de ligne"
^ : "début de ligne (sauf caractères invisibles)"
w : "fin du mot"
$ : "fin de ligne"
G : "fin du fichier"
~~~

afficher les caractères invisibles :

~~~{.bash}
:set list
~~~

coloration syntaxique :

~~~{.bash}
:syntax on
~~~

modifier la couleur pour *desert* :

~~~{.bash}
:color desert
~~~

### [Dé]Commenter du code

Pour commenter, suivre la liste des commandes suivante :

~~~{.bash}
C-v : "Mode «Visual» activé"
<fleches_directionneles> : "Choisir la zone concernée"
I : "Insérer en début de ligne - active le mode «Insert»"
<char> : "Caractère du commentaire en question - selon langage"
Echap : "Quitter le mode «Insert»"
~~~

Pour décomenter, suivre la liste des commandes suivante :

~~~{.bash}
C-v : "Mode «Visual» activé"
<fleches_directionneles> : "Choisir la zone concernée"
x : "Supprimer le caractère"
~~~